## mingw-w64 13.0.0

=== mingw-w64-libraries/winpthreads/tests_pthread/Makefile ===
# Makefile for the pthreads test suite.
# If all of the .pass files can be created, the test suite has passed.
#
# --------------------------------------------------------------------------
#
#      Pthreads-win32 - POSIX Threads Library for Win32
#      Copyright(C) 1998 John E. Bossom
#      Copyright(C) 1999,2005 Pthreads-win32 contributors
# 
#      Contact Email: rpj@callisto.canberra.edu.au
# 
#      The current list of contributors is contained
#      in the file CONTRIBUTORS included with the source
#      code distribution. The list can also be seen at the
#      following World Wide Web location:
#      http://sources.redhat.com/pthreads-win32/contributors.html
# 
#      This library is free software; you can redistribute it and/or
#      modify it under the terms of the GNU Lesser General Public
#      License as published by the Free Software Foundation; either
#      version 2 of the License, or (at your option) any later version.
# 
#      This library is distributed in the hope that it will be useful,
#      but WITHOUT ANY WARRANTY; without even the implied warranty of
#      MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
#      Lesser General Public License for more details.
# 
#      You should have received a copy of the GNU Lesser General Public
#      License along with this library in the file COPYING.LIB;
#      if not, write to the Free Software Foundation, Inc.,
#      59 Temple Place - Suite 330, Boston, MA 02111-1307, USA
#

DLL_VER	= 2

CP	= copy
RM	= erase
CAT	= type
MKDIR	= mkdir
TOUCH	= echo Passed >
ECHO	= @echo

# The next path is relative to $BUILD_DIR
QAPC	= ..\QueueUserAPCEx\User\quserex.dll

CPHDR	= pthread.h semaphore.h sched.h

OPTIM	= /O2 /Ob0

XXLIBS	= ws2_32.lib

# C++ Exceptions
VCEFLAGS	= /GX /TP /DPtW32NoCatchWarn /D__CLEANUP_CXX
VCELIB	= pthreadVCE$(DLL_VER).lib
VCEDLL	= pthreadVCE$(DLL_VER).dll
# Structured Exceptions
VSEFLAGS	= /D__CLEANUP_SEH
VSELIB	= pthreadVSE$(DLL_VER).lib
VSEDLL	= pthreadVSE$(DLL_VER).dll
# C cleanup code
VCFLAGS	= /D__CLEANUP_C
VCLIB	= pthreadVC$(DLL_VER).lib
VCDLL	= pthreadVC$(DLL_VER).dll
# C++ Exceptions in application - using VC version of pthreads dll
VCXFLAGS	= /GX /TP /D__CLEANUP_C

# Defaults
CPLIB	= $(VCLIB)
CPDLL	= $(VCDLL)

CFLAGS= $(OPTIM) /W3 /MD /nologo /Yd /Zi
LFLAGS= /INCREMENTAL:NO
INCLUDES=-I.
BUILD_DIR=..

COPYFILES	= $(CPHDR) $(CPLIB) $(CPDLL) $(QAPC)

TEST		=
EHFLAGS	=

# If a test case returns a non-zero exit code to the shell, make will
# stop.

PASSES= sizes.pass  loadfree.pass \
	  self1.pass  mutex5.pass  \
	  mutex1.pass  mutex1n.pass  mutex1e.pass  mutex1r.pass  \
	  semaphore1.pass  semaphore2.pass  semaphore3.pass  \
	  mutex2.pass  mutex3.pass  \
	  mutex2r.pass  mutex2e.pass  mutex3r.pass  mutex3e.pass  \
	  condvar1.pass  condvar1_1.pass  condvar1_2.pass  condvar2.pass  condvar2_1.pass  \
	  exit1.pass  create1.pass  create2.pass  reuse1.pass  reuse2.pass  equal1.pass  \
	  kill1.pass  valid1.pass  valid2.pass  \
	  exit2.pass  exit3.pass  exit4.pass  exit5.pass  \
	  join0.pass  join1.pass  detach1.pass  join2.pass join3.pass  \
	  mutex4.pass  mutex6.pass  mutex6n.pass  mutex6e.pass  mutex6r.pass  \
	  mutex6s.pass  mutex6es.pass  mutex6rs.pass  \
	  mutex7.pass  mutex7n.pass  mutex7e.pass  mutex7r.pass  \
	  mutex8.pass  mutex8n.pass  mutex8e.pass  mutex8r.pass  \
	  count1.pass  \
	  once1.pass  once2.pass  once3.pass  once4.pass  \
	  self2.pass  \
	  cancel1.pass  cancel2.pass  \
	  semaphore4.pass  semaphore4t.pass  semaphore5.pass  \
	  barrier1.pass  barrier2.pass  barrier3.pass  barrier4.pass  barrier5.pass  barrier6.pass  \
	  tsd1.pass  tsd2.pass  delay1.pass  delay2.pass  eyal1.pass  \
	  condvar3.pass  condvar3_1.pass  condvar3_2.pass  condvar3_3.pass  \
	  condvar4.pass  condvar5.pass  condvar6.pass  \
	  condvar7.pass  condvar8.pass  condvar9.pass  \
	  errno1.pass  \
	  rwlock1.pass  rwlock2.pass  rwlock3.pass  rwlock4.pass  \
	  rwlock5.pass  rwlock6.pass  rwlock7.pass  rwlock8.pass  \
	  rwlock2_t.pass  rwlock3_t.pass  rwlock4_t.pass  rwlock5_t.pass  rwlock6_t.pass  rwlock6_t2.pass  \
	  context1.pass  \
	  cancel3.pass  cancel4.pass  cancel5.pass  cancel6a.pass  cancel6d.pass  \
	  cancel7.pass  cancel8.pass  \
	  cleanup0.pass  cleanup1.pass  cleanup2.pass  cleanup3.pass  \
	  priority1.pass priority2.pass inherit1.pass  \
	  spin1.pass  spin2.pass  spin3.pass  spin4.pass  \
	  exception1.pass  exception2.pass  exception3.pass  \
	  cancel9.pass  create3.pass  stress1.pass

BENCHRESULTS = \
	  benchtest1.bench benchtest2.bench benchtest3.bench benchtest4.bench benchtest5.bench \
	  benchtest6.bench

STRESSRESULTS = \
	  stress1.stress

STATICRESULTS = \
	  sizes.pass  \
	  self1.pass  mutex5.pass  \
	  mutex1.pass  mutex1n.pass  mutex1e.pass  mutex1r.pass  \
	  semaphore1.pass  semaphore2.pass  semaphore3.pass  \
	  mutex2.pass  mutex3.pass  \
	  mutex2r.pass  mutex2e.pass  mutex3r.pass  mutex3e.pass  \
	  condvar1.pass  condvar1_1.pass  condvar1_2.pass  condvar2.pass  condvar2_1.pass  \
	  exit1.pass  create1.pass  create2.pass  reuse1.pass  reuse2.pass  equal1.pass  \
	  kill1.pass  valid1.pass  valid2.pass  \
	  exit2.pass  exit3.pass  exit4.pass  exit5.pass  \
	  join0.pass  join1.pass  detach1.pass  join2.pass join3.pass  \
	  mutex4.pass  mutex6.pass  mutex6n.pass  mutex6e.pass  mutex6r.pass  \
	  mutex6s.pass  mutex6es.pass  mutex6rs.pass  \
	  mutex7.pass  mutex7n.pass  mutex7e.pass  mutex7r.pass  \
	  mutex8.pass  mutex8n.pass  mutex8e.pass  mutex8r.pass  \
	  count1.pass  \
	  once1.pass  once2.pass  once3.pass  once4.pass  \
	  self2.pass  \
	  cancel1.pass  cancel2.pass  \
	  semaphore4.pass  semaphore4t.pass  semaphore5.pass  \
	  barrier1.pass  barrier2.pass  barrier3.pass  barrier4.pass  barrier5.pass  barrier6.pass  \
	  tsd1.pass  tsd2.pass  delay1.pass  delay2.pass  eyal1.pass  \
	  condvar3.pass  condvar3_1.pass  condvar3_2.pass  condvar3_3.pass  \
	  condvar4.pass  condvar5.pass  condvar6.pass  \
	  condvar7.pass  condvar8.pass  condvar9.pass  \
	  errno1.pass  \
	  rwlock1.pass  rwlock2.pass  rwlock3.pass  rwlock4.pass  \
	  rwlock5.pass  rwlock6.pass  rwlock7.pass  rwlock8.pass  \
	  rwlock2_t.pass  rwlock3_t.pass  rwlock4_t.pass  rwlock5_t.pass  rwlock6_t.pass  rwlock6_t2.pass  \
	  context1.pass  \
	  cancel3.pass  cancel4.pass  cancel5.pass  cancel6a.pass  cancel6d.pass  \
	  cancel7.pass  cancel8.pass  \
	  cleanup0.pass  cleanup1.pass  cleanup2.pass  cleanup3.pass  \
	  priority1.pass priority2.pass inherit1.pass  \
	  spin1.pass  spin2.pass  spin3.pass  spin4.pass  \
	  exception1.pass  exception2.pass  exception3.pass  \
	  cancel9.pass  create3.pass  stress1.pass

help:
	@ $(ECHO) Run one of the following command lines:
	@ $(ECHO) nmake clean VC          (to test using VC dll with VC (no EH) apps)
	@ $(ECHO) nmake clean VC-bench    (to benchtest using VC dll with C bench apps)
	@ $(ECHO) nmake clean VC-stress   (to stresstest using VC dll with C stress apps)
	@ $(ECHO) nmake clean VC-static   (to test using VC static lib with VC (no EH) apps)
	@ $(ECHO) nmake clean VCX         (to test using VC dll with VC++ (EH) applications)
	@ $(ECHO) nmake clean VCX-bench   (to benchtest using VC dll with C++ bench apps)
	@ $(ECHO) nmake clean VCX-stress  (to stresstest using VC dll with C++ stress apps)
	@ $(ECHO) nmake clean VCE         (to test using the VCE dll with VC++ EH applications)
	@ $(ECHO) nmake clean VCE-bench   (to benchtest using VCE dll with C++ bench apps)
	@ $(ECHO) nmake clean VCE-stress  (to stresstest using VCE dll with C++ stress apps)
	@ $(ECHO) nmake clean VSE         (to test using VSE dll with VC (SEH) apps)
	@ $(ECHO) nmake clean VSE-bench   (to benchtest using VSE dll with SEH bench apps)
	@ $(ECHO) nmake clean VSE-stress  (to stresstest using VSE dll with SEH stress apps)

all:
	@ nmake clean VC
	@ nmake clean VCX
	@ nmake clean VCE
	@ nmake clean VSE
	@ nmake clean VC-bench
	@ nmake clean VC-stress

# This allows an individual test application to be made using the default lib.
# e.g. nmake clean test cancel3.exe
test: $(CPLIB) $(CPDLL) $(CPHDR) $(QAPC)

tests: $(CPLIB) $(CPDLL) $(CPHDR) $(QAPC) $(PASSES)
	@ $(ECHO) ALL TESTS PASSED! Congratulations!

benchtests: $(CPLIB) $(CPDLL) $(CPHDR) $(XXLIBS) $(BENCHRESULTS)
	@ $(ECHO) ALL BENCH TESTS DONE.

stresstests: $(CPLIB) $(CPDLL) $(CPHDR) $(STRESSRESULTS)
	@ $(ECHO) ALL STRESS TESTS DONE.

statictests: $(CPLIB) $(CPDLL) $(CPHDR) $(STATICRESULTS)
	@ $(ECHO) ALL STATIC TESTS DONE.

sizes.pass: sizes.exe
	@ $(ECHO) ... Running $(TEST)$(DLL_VER) test: $*.exe
	@ .\$*.exe > SIZES.$(TEST)
	@ $(CAT) SIZES.$(TEST)
	@ $(ECHO) ...... Passed
	@ $(TOUCH) $*.pass

$(PASSES): $*.exe
	@ $(ECHO) ... Running $(TEST) test: $*.exe
	@ $(ECHO) .\$*.exe
	@ $(ECHO) ...... Passed
	@ $(TOUCH) $*.pass

$(BENCHRESULTS): $*.exe
	@ $(ECHO) ... Running $(TEST) benchtest: $*.exe
	@ $(ECNO) .\$*.exe
	@ $(ECHO) ...... Done
	@ $(TOUCH) $*.bench

$(STRESSRESULTS): $*.exe
	@ $(ECHO) ... Running $(TEST) stresstest: $*.exe
	@ $(ECHO) .\$*.exe
	@ $(ECHO) ...... Done
	@ $(TOUCH) $*.pass

VC:
	@ nmake TEST="$@" CPLIB="$(VCLIB)" CPDLL="$(VCDLL)" EHFLAGS="$(VCFLAGS)" tests

VCE:
	@ nmake TEST="$@" CPLIB="$(VCELIB)" CPDLL="$(VCEDLL)" EHFLAGS="$(VCEFLAGS)" tests

VSE:	
	@ nmake TEST="$@" CPLIB="$(VSELIB)" CPDLL="$(VSEDLL)" EHFLAGS="$(VSEFLAGS)" tests

VCX:
	@ nmake TEST="$@" CPLIB="$(VCLIB)" CPDLL="$(VCDLL)" EHFLAGS="$(VCXFLAGS)" tests

VC-bench:
	@ nmake TEST="$@" CPLIB="$(VCLIB)" CPDLL="$(VCDLL)" EHFLAGS="$(VCFLAGS)" XXLIBS="benchlib.o" benchtests

VCE-bench:
	@ nmake TEST="$@" CPLIB="$(VCELIB)" CPDLL="$(VCEDLL)" EHFLAGS="$(VCEFLAGS)" XXLIBS="benchlib.o" benchtests

VSE-bench:
	@ nmake TEST="$@" CPLIB="$(VSELIB)" CPDLL="$(VSEDLL)" EHFLAGS="$(VSEFLAGS)" XXLIBS="benchlib.o" benchtests

VCX-bench:
	@ nmake TEST="$@" CPLIB="$(VCLIB)" CPDLL="$(VCDLL)" EHFLAGS="$(VCXFLAGS)" XXLIBS="benchlib.o" benchtests

VC-stress:
	@ nmake TEST="$@" CPLIB="$(VCLIB)" CPDLL="$(VCDLL)" EHFLAGS="$(VCFLAGS)" stresstests

VCE-stress:
	@ nmake TEST="$@" CPLIB="$(VCELIB)" CPDLL="$(VCEDLL)" EHFLAGS="$(VCEFLAGS)" stresstests

VSE-stress:
	@ nmake TEST="$@" CPLIB="$(VSELIB)" CPDLL="$(VSEDLL)" EHFLAGS="$(VSEFLAGS)" stresstests

VCX-stress:
	@ nmake TEST="$@" CPLIB="$(VCLIB)" CPDLL="$(VCDLL)" EHFLAGS="$(VCXFLAGS)" stresstests

VC-static:
	@ nmake TEST="$@" CPLIB="$(VCLIB)" CPDLL="" EHFLAGS="$(VCFLAGS) /DPTW32_STATIC_LIB" statictests

.c.exe:
	@ $(ECHO) $(CC) $(EHFLAGS) $(CFLAGS) $(INCLUDES) $< /Fe$@ /link $(LFLAGS) $(CPLIB) $(XXLIBS)
	@ $(CC) $(EHFLAGS) $(CFLAGS) $(INCLUDES) $< /Fe$@ /link $(LFLAGS) $(CPLIB) $(XXLIBS)

.c.o:
	@ $(ECHO) $(CC) $(EHFLAGS) /c $(CFLAGS) $(INCLUDES) $< /Fo$@
	@ $(CC) $(EHFLAGS) $(CFLAGS) /c $(INCLUDES) $< /Fo$@

.c.i:
	@ $(CC) /P $(EHFLAGS) $(CFLAGS) $(INCLUDES) $<

$(COPYFILES):
	@ $(ECHO) Copying $(BUILD_DIR)\$@
	@ $(CP) $(BUILD_DIR)\$@ .

pthread.dll: $(CPDLL)
	@ $(CP) $(CPDLL) pthread.dll
	@ $(CP) $(CPLIB) pthread.lib

clean:
	- $(RM) *.dll
	- $(RM) *.lib
	- $(RM) pthread.h
	- $(RM) semaphore.h
	- $(RM) sched.h
	- $(RM) *.e
	- $(RM) *.i
	- $(RM) *.obj
	- $(RM) *.pdb
	- $(RM) *.o
	- $(RM) *.asm
	- $(RM) *.exe
	- $(RM) *.pass
	- $(RM) *.bench
	- $(RM) *.log

benchtest1.bench:
benchtest2.bench:
benchtest3.bench:
benchtest4.bench:
benchtest5.bench:
benchtest6.bench:

barrier1.pass: semaphore4.pass
barrier2.pass: barrier1.pass
barrier3.pass: barrier2.pass
barrier4.pass: barrier3.pass
barrier5.pass: barrier4.pass
barrier6.pass: barrier5.pass
cancel1.pass: create1.pass
cancel2.pass: cancel1.pass
cancel3.pass: context1.pass
cancel4.pass: cancel3.pass
cancel5.pass: cancel3.pass
cancel6a.pass: cancel3.pass
cancel6d.pass: cancel3.pass
cancel7.pass: kill1.pass
cancel8.pass: cancel7.pass
cancel9.pass: cancel8.pass
cleanup0.pass: cancel5.pass
cleanup1.pass: cleanup0.pass
cleanup2.pass: cleanup1.pass
cleanup3.pass: cleanup2.pass
condvar1.pass:
condvar1_1.pass: condvar1.pass
condvar1_2.pass: join2.pass
condvar2.pass: condvar1.pass
condvar2_1.pass: condvar2.pass join2.pass

## mingw-w64 1.0+20110428

=== debian/changelog ===
mingw-w64 (1.0+20110428-1) unstable; urgency=low

  * New upstream snapshot.
  * Enable all SDKs, including DirectX. (Closes: #625496.)
  * Correctly define arch and indep targets and dependencies.
  * Standards-Version 3.9.2, no change required.
  * Use MinGW version of mb_wc_common.h. (Closes: #626437.)
  * Update float.h to include gcc 4.6 changes.

 -- Stephen Kitt <steve@sk2.org>  Sat, 04 Jun 2011 00:52:35 +0200

mingw-w64 (1.0+20101003-1) unstable; urgency=low

  * New maintainer. (Closes: #594371.)
  * New upstream snapshot:
    - Includes getopt.h. (Closes: #569914.)
  * Build g++ for Win64. (Closes: #600451.)
  * Standards-Version 3.9.1 (new packaging).
  * Include patch from
    http://mingw-w64.svn.sourceforge.net/viewvc/mingw-w64?view=revision&revision=3715
    as suggested by Rafaël Carré.

 -- Stephen Kitt <steve@sk2.org>  Thu, 18 Nov 2010 00:04:46 +0100

mingw-w64 (0~20100125-3) unstable; urgency=low

  * Switch to Architecture: all.  It's meant to have the same content
    regardless of the Debian arch that hosts it.

 -- Robert Millan <rmh.debian@aybabtu.com>  Sat, 30 Jan 2010 02:08:57 +0100

mingw-w64 (0~20100125-2) unstable; urgency=low

  * Match directory name used by gcc-mingw32.

 -- Robert Millan <rmh.debian@aybabtu.com>  Tue, 26 Jan 2010 16:17:25 +0100

mingw-w64 (0~20100125-1) unstable; urgency=low

  * Initial release.  (Closes: #566907)

 -- Robert Millan <rmh.debian@aybabtu.com>  Mon, 25 Jan 2010 22:58:25 +0100

=== debian/control ===
Source: mingw-w64
Section: devel
Priority: extra
Maintainer: Stephen Kitt <steve@sk2.org>
Build-Depends: debhelper (>= 7.0.50~)
Build-Depends-Indep: gcc-mingw-w64 | gcc-mingw-w64-bootstrap
Standards-Version: 3.9.2
Homepage: http://mingw-w64.sf.net
Vcs-Git: git://git.debian.org/collab-maint/mingw-w64.git
Vcs-Browser: http://git.debian.org/?p=collab-maint/mingw-w64.git;a=summary

Package: mingw-w64-dev
Architecture: all
Depends: ${misc:Depends}
Description: Development files for MinGW-w64
 MinGW-w64 provides a development and runtime environment for 32- and
 64-bit Windows applications using the GNU Compiler Collection (gcc).
 .
 This package contains the headers and libraries required to build
 software using MinGW-w64.

Package: mingw-w64
Architecture: all
Depends: ${misc:Depends}, gcc-mingw-w64,
 mingw-w64-dev
Description: Development environment targetting 32- and 64-bit Windows
 MinGW-w64 provides a development and runtime environment for 32- and
 64bit Windows applications using the GNU Compiler Collection (gcc).
 .
 This metapackage provides the full MinGW-w64 development
 environment.

## mingw-w64 1.0+20110523

=== debian/changelog ===
mingw-w64 (1.0+20110523-1build2) oneiric; urgency=low

  * Rebuild using gcc-mingw-w64.

 -- Matthias Klose <doko@ubuntu.com>  Tue, 30 Aug 2011 15:40:52 +0200

mingw-w64 (1.0+20110523-1build1) oneiric; urgency=low

  * Fix b-d on gcc-mingw-w64-bootstrap.

 -- Matthias Klose <doko@ubuntu.com>  Mon, 29 Aug 2011 15:33:49 +0200

mingw-w64 (1.0+20110523-1) unstable; urgency=low

  * New upstream snapshot.
  * This version and the previous breaks the gcc-4.5-based gcc-mingw-
    w64.
  * Properly specify the format of debian/copyright.

 -- Stephen Kitt <steve@sk2.org>  Mon, 13 Jun 2011 23:06:42 +0200

=== debian/control ===
--- 
+++ 
@@ -3,7 +3,8 @@
 Priority: extra
 Maintainer: Stephen Kitt <steve@sk2.org>
 Build-Depends: debhelper (>= 7.0.50~)
-Build-Depends-Indep: gcc-mingw-w64 | gcc-mingw-w64-bootstrap
+Build-Depends-Indep:
+ gcc-mingw-w64 (>= 4.6.0) | gcc-mingw-w64-bootstrap
 Standards-Version: 3.9.2
 Homepage: http://mingw-w64.sf.net
 Vcs-Git: git://git.debian.org/collab-maint/mingw-w64.git
@@ -12,6 +13,7 @@
 Package: mingw-w64-dev
 Architecture: all
 Depends: ${misc:Depends}
+Breaks: gcc-mingw-w64 (<< 4.6.0)
 Description: Development files for MinGW-w64
  MinGW-w64 provides a development and runtime environment for 32- and
  64-bit Windows applications using the GNU Compiler Collection (gcc).
@@ -21,8 +23,7 @@
 
 Package: mingw-w64
 Architecture: all
-Depends: ${misc:Depends}, gcc-mingw-w64,
- mingw-w64-dev
+Depends: gcc-mingw-w64, mingw-w64-dev, ${misc:Depends}
 Description: Development environment targetting 32- and 64-bit Windows
  MinGW-w64 provides a development and runtime environment for 32- and
  64bit Windows applications using the GNU Compiler Collection (gcc).

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-
# Build mingw-w64.
# Copyright © 2010 Stephen Kitt <steve@sk2.org>

SHELL=/bin/bash

# Uncomment this to turn on verbose mode.
#export DH_VERBOSE=1

top_dir := $(shell pwd)
build_dir := $(top_dir)/build
stampdir := $(top_dir)/stamp
deb_version := $(shell dpkg-parsechangelog | sed -ne "s/^Version: \(.*\)/\1/p")
deb_upstream_version := $(shell echo $(deb_version) | cut -d- -f1)
gnu_upstream_version := $(shell echo $(deb_upstream_version) | cut -d. -f1-3)

# Build the full MinGW-w64 development package.
package := mingw-w64-dev
subprojects := headers crt

targets := i686-w64-mingw32 x86_64-w64-mingw32

CFLAGS = -Wall -g
# TODO Handle install with nostrip?

ifneq (,$(filter noopt,$(DEB_BUILD_OPTIONS)))
    CFLAGS += -O0
else
    CFLAGS += -O2
endif

#number of jobs to run for build
ifeq ($(USE_NJOBS),no)
  NJOBS :=
  USE_CPUS := 1
else
  MEM_PER_CPU = 128
  NUM_CPUS := $(shell if echo $(USE_NJOBS) | grep -q -E '^[0-9]+$$'; \
                        then echo $(USE_NJOBS); \
                        else getconf _NPROCESSORS_ONLN 2>/dev/null || echo 1; fi)
  USE_CPUS := $(shell mt=`awk '/^MemTotal/ { print $$2 }' /proc/meminfo`; \
                        awk -vn=$(NUM_CPUS) -vmt=$$mt -vm=$(MEM_PER_CPU) \
                                'END { mt/=1024; n2 = int(mt/m); print n==1 ? 1 : n2<n+1 ? n2 : n+1}' < /dev/null)
  ifneq (,$(strip $(USE_CPUS)))
    NJOBS := -j $(USE_CPUS)
  endif
endif

# Support parallel=<n> in DEB_BUILD_OPTIONS (see #209008)
ifneq (,$(filter parallel=%,$(subst $(COMMA), ,$(DEB_BUILD_OPTIONS))))
  NJOBS := -j $(subst parallel=,,$(filter parallel=%,$(subst $(COMMA), ,$(DEB_BUILD_OPTIONS))))
endif

clean:
	dh_testdir
	dh_testroot
	dh_clean
	rm -rf $(stampdir) $(build_dir) $(upstream_dir) autotools_files series

CONFFLAGS = --prefix=/usr
CFLAGS += -I$(top_dir)/mingw-w64-headers/include

configure-stamp: $(patsubst %,configure-stamp-%,$(subprojects))
	touch $@

configure-stamp-headers:
	dh_testdir
	for target in $(targets); do \
		mkdir -p $(build_dir)/$$target/headers && \
		cd $(build_dir)/$$target/headers && \
		$(top_dir)/mingw-w64-headers/configure $(CONFFLAGS) --host=$$target --with-sdk=all; \
	done
	touch $@

configure-stamp-crt:
	dh_testdir
	for target in $(targets); do \
		mkdir -p $(build_dir)/$$target/crt && \
		cd $(build_dir)/$$target/crt && \
		$(top_dir)/mingw-w64-crt/configure $(CONFFLAGS) --host=$$target $$(if [ "$${target/-w64-mingw32/}" == "i686" ]; then echo --enable-lib32 --disable-lib64; else echo --disable-lib32 --enable-lib64; fi); \
	done
	touch $@

build: build-indep
build-indep: build-stamp
build-stamp: configure-stamp
	dh_testdir
	for target in $(targets); do \
		for subproject in $(subprojects); do \
			cd $(build_dir)/$$target/$$subproject && \
			$(MAKE) $(NJOBS); \
		done; \
	done
	touch $@

install: install-stamp
install-stamp: build-stamp
	dh_testdir
	dh_testroot
	dh_prep
	for target in $(targets); do \
		for subproject in $(subprojects); do \
			mkdir -p $(build_dir)/$$target/$$subproject && \
			cd $(build_dir)/$$target/$$subproject && \
			$(MAKE) install DESTDIR=$(top_dir)/debian/$(package); \
		done; \
	done
	rmdir $(top_dir)/debian/$(package)/usr/include
	touch $@

binary-indep: build-indep install
	dh_testdir
	dh_testroot
	dh_installdocs
	dh_installman
	dh_installchangelogs
	dh_lintian
	dh_strip -Xw64-mingw32/lib
	dh_compress
	dh_fixperms
	dh_installdeb
	dh_shlibdeps
	dh_gencontrol
	dh_md5sums
	dh_builddeb

binary-arch:

binary: binary-indep

.PHONY: binary-indep binary-arch binary clean build-indep build install

## mingw-w64 2.0

=== debian/changelog ===
mingw-w64 (2.0-2) unstable; urgency=low

  * Disable dpkg-buildflags hardening. (LP: #880726.)
  * Apply upstream fix for imagehlp.h's extern "C" declarations (in
    particular this is required to build Ekiga).

 -- Stephen Kitt <steve@sk2.org>  Mon, 24 Oct 2011 22:39:43 +0200

mingw-w64 (2.0-1) unstable; urgency=low

  * New upstream release.

 -- Stephen Kitt <steve@sk2.org>  Thu, 13 Oct 2011 00:41:25 +0200

mingw-w64 (2.0~rc3-1) unstable; urgency=low

  [ Stephen Kitt ]
  * New upstream release candidate.

  [ Didier Raboud ]
  * Confidently setting the DM-Upload-Allowed flag to yes.

 -- Stephen Kitt <steve@sk2.org>  Mon, 10 Oct 2011 10:39:38 +0200

mingw-w64 (2.0~rc2-1) unstable; urgency=low

  * New upstream release candidate.
    - Includes fixed d2d1.h. (Closes: #638620.)
  * Simplify debian/rules.
  * Add "Architecture: any" mingw-w64-tools package to ship gendef and
    genidl.
  * Provide manpages for gendef and genidl.
  * Ship libmangle and libpseh in mingw-w64-dev (32-bit only for
    libpseh).
  * Correct debian/copyright ("Upstream-Name" instead of "Name", correct
    license for mingw-w64-headers/ddk/include/ddk/csq.h).
  * Add spelling-fix.patch to fix small spelling mistake in gendef.

 -- Stephen Kitt <steve@sk2.org>  Thu, 06 Oct 2011 23:32:07 +0200

mingw-w64 (2.0~rc1-1) unstable; urgency=low

  * New upstream release candidate.
  * mingw-w64 now provides __uuidof() where necessary. (Closes: #625497.)
  * Removed patches:
    - 01-guiddef-svn-3715.patch, originally taken from upstream;
    - 02-get_codepage.patch, fixed differently;
    - 03-gcc-4.6-float.patch, no longer relevant (mingw-w64 no longer
      ships float.h).
  * Add empty build-arch target (policy 4.9).

 -- Stephen Kitt <steve@sk2.org>  Sun, 07 Aug 2011 23:02:01 +0200

## mingw-w64 2.0.1

=== debian/changelog ===
mingw-w64 (2.0.1-1) unstable; urgency=low

  * New upstream release (notably adding GDI+ support).
  * Drop imagehlp-fix.patch, included upstream.

 -- Stephen Kitt <steve@sk2.org>  Mon, 21 Nov 2011 23:05:31 +0100

=== debian/control ===
--- 
+++ 
@@ -4,11 +4,12 @@
 Maintainer: Stephen Kitt <steve@sk2.org>
 Build-Depends: debhelper (>= 7.0.50~)
 Build-Depends-Indep:
- gcc-mingw-w64 (>= 4.6.0) | gcc-mingw-w64-bootstrap
+ gcc-mingw-w64 (>= 4.6.0) | gcc-mingw-w64-bootstrap (>= 4.6.0)
 Standards-Version: 3.9.2
 Homepage: http://mingw-w64.sf.net
 Vcs-Git: git://git.debian.org/collab-maint/mingw-w64.git
 Vcs-Browser: http://git.debian.org/?p=collab-maint/mingw-w64.git;a=summary
+DM-Upload-Allowed: yes
 
 Package: mingw-w64-dev
 Architecture: all
@@ -30,3 +31,14 @@
  .
  This metapackage provides the full MinGW-w64 development
  environment.
+
+Package: mingw-w64-tools
+Architecture: any
+Depends: ${shlibs:Depends}, ${misc:Depends}
+Description: Development tools for 32- and 64-bit Windows
+ MinGW-w64 provides a development and runtime environment for 32- and
+ 64bit Windows applications using the GNU Compiler Collection (gcc).
+ .
+ This package contains the gendef and genidl tools, used to extract
+ respectively DLL exports and IDL information from Windows
+ executables.

## mingw-w64 2.0.1+svn4784

=== debian/changelog ===
mingw-w64 (2.0.1+svn4784-2) unstable; urgency=low

  * Mention "x86" and "x64" as used on Windows (see thread starting at
    http://lists.debian.org/4EBA730A.7060707@greffrath.com for
    rationale; the 32-/64-bit split will come later).
  * Enable secure API (required in particular for newer versions of Wine
    Gecko).
  * Allow bootstrapping again (thanks to Sam Morris for pointing out
    that bootstrapping the mingw-w64 package set no longer worked!).

 -- Stephen Kitt <steve@sk2.org>  Wed, 15 Feb 2012 01:00:43 +0100

mingw-w64 (2.0.1+svn4784-1) unstable; urgency=low

  * New upstream snapshot.
    - Builds libmsi.a for i686. (Closes: #652362.)
    - Includes fixed asprintf as requested by Rafaël Carré.

 -- Stephen Kitt <steve@sk2.org>  Tue, 31 Jan 2012 22:57:13 +0100

=== debian/control ===
--- 
+++ 
@@ -17,7 +17,8 @@
 Breaks: gcc-mingw-w64 (<< 4.6.0)
 Description: Development files for MinGW-w64
  MinGW-w64 provides a development and runtime environment for 32- and
- 64-bit Windows applications using the GNU Compiler Collection (gcc).
+ 64-bit (x86 and x64) Windows applications using the Windows API and
+ the GNU Compiler Collection (gcc).
  .
  This package contains the headers and libraries required to build
  software using MinGW-w64.
@@ -27,7 +28,8 @@
 Depends: gcc-mingw-w64, mingw-w64-dev, ${misc:Depends}
 Description: Development environment targetting 32- and 64-bit Windows
  MinGW-w64 provides a development and runtime environment for 32- and
- 64bit Windows applications using the GNU Compiler Collection (gcc).
+ 64-bit (x86 and x64) Windows applications using the Windows API and
+ the GNU Compiler Collection (gcc).
  .
  This metapackage provides the full MinGW-w64 development
  environment.
@@ -37,7 +39,8 @@
 Depends: ${shlibs:Depends}, ${misc:Depends}
 Description: Development tools for 32- and 64-bit Windows
  MinGW-w64 provides a development and runtime environment for 32- and
- 64bit Windows applications using the GNU Compiler Collection (gcc).
+ 64-bit (x86 and x64) Windows applications using the Windows API and
+ the GNU Compiler Collection (gcc).
  .
  This package contains the gendef and genidl tools, used to extract
  respectively DLL exports and IDL information from Windows

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-
# Build mingw-w64.
# Copyright © 2010, 2011 Stephen Kitt <steve@sk2.org>

SHELL=/bin/bash

# Uncomment this to turn on verbose mode.
#export DH_VERBOSE=1

top_dir := $(shell pwd)
build_dir := $(top_dir)/build
deb_version := $(shell dpkg-parsechangelog | sed -ne "s/^Version: \(.*\)/\1/p")
deb_upstream_version := $(shell echo $(deb_version) | cut -d- -f1)
gnu_upstream_version := $(shell echo $(deb_upstream_version) | cut -d. -f1-3)

# Target architectures
target32 := i686-w64-mingw32
target64 := x86_64-w64-mingw32
targets := $(target32) $(target64)

# No hardening support for now
dpkg_buildflags = DEB_BUILD_MAINT_OPTIONS="hardening=-all" dpkg-buildflags

CFLAGS = $(shell $(dpkg_buildflags) --get CFLAGS)
CPPFLAGS = $(shell $(dpkg_buildflags) --get CPPFLAGS)
CXXFLAGS = $(shell $(dpkg_buildflags) --get CXXFLAGS)
FFLAGS = $(shell $(dpkg_buildflags) --get FFLAGS)
LDFLAGS = $(shell $(dpkg_buildflags) --get LDFLAGS)
export CFLAGS CPPFLAGS CXXFLAGS FFLAGS LDFLAGS

clean:
	dh_testdir
	dh_testroot
	dh_clean
	rm -rf $(build_dir) $(upstream_dir) autotools_files series tmp *-stamp

CONFFLAGS = --prefix=/usr

# Build and install the headers first, so the remaining subprojects can use
# them during the build
headers-stamp:
	for target in $(targets); do \
		dh_auto_configure -D$(top_dir)/mingw-w64-headers -B$(build_dir)/$$target/headers -- --host=$$target --enable-sdk=all --enable-secure-api && \
		dh_auto_build -D$(top_dir)/mingw-w64-headers -B$(build_dir)/$$target/headers && \
		dh_auto_install -D$(top_dir)/mingw-w64-headers -B$(build_dir)/$$target/headers; \
	done
	touch $@

# Build the two arch-dependent subprojects
build-arch-stamp:
	for tool_dir in $(top_dir)/mingw-w64-tools/*; do \
		dh_auto_configure -D$$tool_dir -B$(build_dir)/$$(basename $$tool_dir) && \
		dh_auto_build -D$$tool_dir -B$(build_dir)/$$(basename $$tool_dir) && \
		dh_auto_install -D$$tool_dir -B$(build_dir)/$$(basename $$tool_dir); \
	done
	touch $@

# Build the arch-independent subprojects, with different options for each
# target architecture
build-indep-stamp: headers-stamp
	# When bootstrapping, the extra libraries can't be built, so try
	# configuring with libraries and if that fails without
	CPPFLAGS="$(CPPFLAGS) -I$(top_dir)/debian/tmp/usr/$(target32)/include" dh_auto_configure -B$(build_dir)/$(target32)/all -- --host=$(target32) --with-libraries=all --enable-lib32 --disable-lib64 --enable-secure-api || \
	CPPFLAGS="$(CPPFLAGS) -I$(top_dir)/debian/tmp/usr/$(target32)/include" dh_auto_configure -B$(build_dir)/$(target32)/all -- --host=$(target32) --enable-lib32 --disable-lib64 --enable-secure-api
	CPPFLAGS="$(CPPFLAGS) -I$(top_dir)/debian/tmp/usr/$(target64)/include" dh_auto_configure -B$(build_dir)/$(target64)/all -- --host=$(target64) --with-libraries=libmangle --disable-lib32 --enable-lib64 --enable-secure-api || \
	CPPFLAGS="$(CPPFLAGS) -I$(top_dir)/debian/tmp/usr/$(target64)/include" dh_auto_configure -B$(build_dir)/$(target64)/all -- --host=$(target64) --disable-lib32 --enable-lib64 --enable-secure-api
# Move headers and libraries to target-specific folders
	set -e; \
	for target in $(targets); do \
		dh_auto_build -B$(build_dir)/$$target/all && \
		dh_auto_install -B$(build_dir)/$$target/all && \
		if [ -f $(top_dir)/debian/tmp/usr/include/libmangle.h ]; then \
			mv $(top_dir)/debian/tmp/usr/include/libmangle.h $(top_dir)/debian/tmp/usr/$$target/include/; \
		fi && \
		if [ -d $(top_dir)/debian/tmp/usr/include/pseh ]; then \
			mv $(top_dir)/debian/tmp/usr/include/pseh $(top_dir)/debian/tmp/usr/$$target/include/; \
		fi && \
		if [ -f $(top_dir)/debian/tmp/usr/lib/libmangle.a ]; then \
			mv $(top_dir)/debian/tmp/usr/lib/libmangle.a $(top_dir)/debian/tmp/usr/$$target/lib/; \
		fi && \
		if [ -f $(top_dir)/debian/tmp/usr/lib/libpseh.a ]; then \
			mv $(top_dir)/debian/tmp/usr/lib/libpseh.a $(top_dir)/debian/tmp/usr/$$target/lib/; \
		fi; \
	done
	touch $@

build: build-arch
build-arch: build-arch-stamp
build-indep: build-indep-stamp

binary-indep: build-indep
	dh $@

binary-arch: build-arch
	dh $@

binary: binary-indep binary-arch

.PHONY: binary-indep binary-arch binary clean build-indep build-arch build install

## mingw-w64 2.0.2

=== debian/changelog ===
mingw-w64 (2.0.2-1) unstable; urgency=low

  * New upstream release.
  * Following the gcc-mingw-w64 package split, make mingw-w64 depend on
    gcc-mingw-w64 and g++-mingw-w64, and correct the description
    appropriately.
  * Update watch file to take into account any upstream tarball.
  * Standards-Version 3.9.3, no change required.
  * Make sure we get the split gcc-mingw-w64 packages (to avoid
    attempting a build with only the architecture-independent gcc-mingw-
    w64 package).

 -- Stephen Kitt <steve@sk2.org>  Wed, 18 Apr 2012 00:33:40 +0200

=== debian/control ===
--- 
+++ 
@@ -4,8 +4,9 @@
 Maintainer: Stephen Kitt <steve@sk2.org>
 Build-Depends: debhelper (>= 7.0.50~)
 Build-Depends-Indep:
- gcc-mingw-w64 (>= 4.6.0) | gcc-mingw-w64-bootstrap (>= 4.6.0)
-Standards-Version: 3.9.2
+ gcc-mingw-w64-i686 | gcc-mingw-w64-bootstrap (>= 4.6.0),
+ gcc-mingw-w64-x86-64 | gcc-mingw-w64-bootstrap (>= 4.6.0)
+Standards-Version: 3.9.3
 Homepage: http://mingw-w64.sf.net
 Vcs-Git: git://git.debian.org/collab-maint/mingw-w64.git
 Vcs-Browser: http://git.debian.org/?p=collab-maint/mingw-w64.git;a=summary
@@ -25,14 +26,17 @@
 
 Package: mingw-w64
 Architecture: all
-Depends: gcc-mingw-w64, mingw-w64-dev, ${misc:Depends}
+Depends: gcc-mingw-w64, g++-mingw-w64 | gcc-mingw-w64 (<< 4.6.3-3+4), mingw-w64-dev, ${misc:Depends}
 Description: Development environment targetting 32- and 64-bit Windows
  MinGW-w64 provides a development and runtime environment for 32- and
  64-bit (x86 and x64) Windows applications using the Windows API and
  the GNU Compiler Collection (gcc).
  .
- This metapackage provides the full MinGW-w64 development
- environment.
+ This metapackage provides the MinGW-w64 development environment,
+ including C and C++ compilers. Ada, Fortran, Objective-C and
+ Objective-C++ compilers are available respectively in the
+ gnat-mingw-w64, gfortran-mingw-w64, gobjc-mingw-w64 and
+ gojbc++-mingw-w64 packages.
 
 Package: mingw-w64-tools
 Architecture: any

## mingw-w64 2.0.3

=== debian/changelog ===
mingw-w64 (2.0.3-1) unstable; urgency=low

  * New upstream release.
  * Split the -dev package into 32- and 64-bit variants.
  * Fix "Error when including dshow.h" by ensuring all SDKs are enabled
    throughout the build. (Closes: #661442)

 -- Stephen Kitt <steve@sk2.org>  Thu, 10 May 2012 17:56:59 +0200

=== debian/control ===
--- 
+++ 
@@ -13,20 +13,47 @@
 DM-Upload-Allowed: yes
 
 Package: mingw-w64-dev
+Section: oldlibs
+Architecture: all
+Depends: mingw-w64-i686-dev, mingw-w64-x86-64-dev, ${misc:Depends}
+Breaks: gcc-mingw-w64 (<< 4.6.0)
+Description: Development files for MinGW-w64 (transitional package)
+ MinGW-w64 provides a development and runtime environment for 32- and
+ 64-bit (x86 and x64) Windows applications using the Windows API and
+ the GNU Compiler Collection (gcc).
+ .
+ This transitional package provides the headers and libraries required
+ to build software using MinGW-w64.
+
+Package: mingw-w64-i686-dev
 Architecture: all
 Depends: ${misc:Depends}
-Breaks: gcc-mingw-w64 (<< 4.6.0)
-Description: Development files for MinGW-w64
+Breaks: gcc-mingw-w64 (<< 4.6.0), mingw-w64-dev (<< 2.0.3-1)
+Replaces: mingw-w64-dev (<< 2.0.3-1)
+Description: Development files for MinGW-w64 targeting Win32
  MinGW-w64 provides a development and runtime environment for 32- and
  64-bit (x86 and x64) Windows applications using the Windows API and
  the GNU Compiler Collection (gcc).
  .
  This package contains the headers and libraries required to build
- software using MinGW-w64.
+ 32-bit software using MinGW-w64.
+
+Package: mingw-w64-x86-64-dev
+Architecture: all
+Depends: ${misc:Depends}
+Breaks: gcc-mingw-w64 (<< 4.6.0), mingw-w64-dev (<< 2.0.3-1)
+Replaces: mingw-w64-dev (<< 2.0.3-1)
+Description: Development files for MinGW-w64 targeting Win64
+ MinGW-w64 provides a development and runtime environment for 32- and
+ 64-bit (x86 and x64) Windows applications using the Windows API and
+ the GNU Compiler Collection (gcc).
+ .
+ This package contains the headers and libraries required to build
+ 64-bit software using MinGW-w64.
 
 Package: mingw-w64
 Architecture: all
-Depends: gcc-mingw-w64, g++-mingw-w64 | gcc-mingw-w64 (<< 4.6.3-3+4), mingw-w64-dev, ${misc:Depends}
+Depends: gcc-mingw-w64, g++-mingw-w64 | gcc-mingw-w64 (<< 4.6.3-3+4), ${misc:Depends}
 Description: Development environment targetting 32- and 64-bit Windows
  MinGW-w64 provides a development and runtime environment for 32- and
  64-bit (x86 and x64) Windows applications using the Windows API and

=== debian/rules ===
--- 
+++ 
@@ -61,10 +61,10 @@
 build-indep-stamp: headers-stamp
 	# When bootstrapping, the extra libraries can't be built, so try
 	# configuring with libraries and if that fails without
-	CPPFLAGS="$(CPPFLAGS) -I$(top_dir)/debian/tmp/usr/$(target32)/include" dh_auto_configure -B$(build_dir)/$(target32)/all -- --host=$(target32) --with-libraries=all --enable-lib32 --disable-lib64 --enable-secure-api || \
-	CPPFLAGS="$(CPPFLAGS) -I$(top_dir)/debian/tmp/usr/$(target32)/include" dh_auto_configure -B$(build_dir)/$(target32)/all -- --host=$(target32) --enable-lib32 --disable-lib64 --enable-secure-api
-	CPPFLAGS="$(CPPFLAGS) -I$(top_dir)/debian/tmp/usr/$(target64)/include" dh_auto_configure -B$(build_dir)/$(target64)/all -- --host=$(target64) --with-libraries=libmangle --disable-lib32 --enable-lib64 --enable-secure-api || \
-	CPPFLAGS="$(CPPFLAGS) -I$(top_dir)/debian/tmp/usr/$(target64)/include" dh_auto_configure -B$(build_dir)/$(target64)/all -- --host=$(target64) --disable-lib32 --enable-lib64 --enable-secure-api
+	CPPFLAGS="$(CPPFLAGS) -I$(top_dir)/debian/tmp/usr/$(target32)/include" dh_auto_configure -B$(build_dir)/$(target32)/all -- --host=$(target32) --with-libraries=all --enable-lib32 --disable-lib64 --enable-sdk=all --enable-secure-api || \
+	CPPFLAGS="$(CPPFLAGS) -I$(top_dir)/debian/tmp/usr/$(target32)/include" dh_auto_configure -B$(build_dir)/$(target32)/all -- --host=$(target32) --enable-lib32 --disable-lib64 --enable-sdk=all --enable-secure-api
+	CPPFLAGS="$(CPPFLAGS) -I$(top_dir)/debian/tmp/usr/$(target64)/include" dh_auto_configure -B$(build_dir)/$(target64)/all -- --host=$(target64) --with-libraries=libmangle --disable-lib32 --enable-lib64 --enable-sdk=all --enable-secure-api || \
+	CPPFLAGS="$(CPPFLAGS) -I$(top_dir)/debian/tmp/usr/$(target64)/include" dh_auto_configure -B$(build_dir)/$(target64)/all -- --host=$(target64) --disable-lib32 --enable-lib64 --enable-sdk=all --enable-secure-api
 # Move headers and libraries to target-specific folders
 	set -e; \
 	for target in $(targets); do \

## mingw-w64 3.0~svn5915

=== debian/changelog ===
mingw-w64 (3.0~svn5915-1) unstable; urgency=low

  * New upstream snapshot.
  * Merge from experimental, tracking upstream trunk (required for
    wine-gecko 1.6 and later, and gcc 4.8 and later). Other than the
    different upstream, the changes are as follows:
    - Build genpeimg, libwinpthreads (which replaces
      libpthreads-mingw-w64), libwinstorecompat and widl.
    - Drop unused contexts and add missing CPU information for widl on
      ia64, s390 and s390x.
    - Rework debian/rules to use declarative rules and recipes, working
      towards making parallel builds possible.
    - Specify the full target prefix as required since 5197.
  * Fix target mangling to build on hurd-i386.
  * Make DLLs non-executable and drop .la files.

 -- Stephen Kitt <skitt@debian.org>  Mon, 24 Jun 2013 19:25:37 +0200

mingw-w64 (2.0.8-1) unstable; urgency=low

  * New upstream release.
  * Switch to my Debian address and drop DM-Upload-Allowed.
  * Use dh_autoreconf to update all the autotools-generated files and
    allow multiple builds in a row.
  * Use canonical VCS URIs.
  * Build libmangle for the current architecture, it's intended for
    gendef; use it to build gendef.
  * Enable hardened builds for gendef and genidl.
  * Fix another spelling mistake in gendef (via libmangle).
  * Standards-Version 3.9.4, no change required.

 -- Stephen Kitt <skitt@debian.org>  Sat, 11 May 2013 23:37:22 +0200

=== debian/control ===
--- 
+++ 
@@ -1,16 +1,15 @@
 Source: mingw-w64
 Section: devel
 Priority: extra
-Maintainer: Stephen Kitt <steve@sk2.org>
-Build-Depends: debhelper (>= 7.0.50~)
+Maintainer: Stephen Kitt <skitt@debian.org>
+Build-Depends: debhelper (>= 7.0.50~), dh-autoreconf
 Build-Depends-Indep:
  gcc-mingw-w64-i686 | gcc-mingw-w64-bootstrap (>= 4.6.0),
  gcc-mingw-w64-x86-64 | gcc-mingw-w64-bootstrap (>= 4.6.0)
-Standards-Version: 3.9.3
+Standards-Version: 3.9.4
 Homepage: http://mingw-w64.sf.net
-Vcs-Git: git://git.debian.org/collab-maint/mingw-w64.git
-Vcs-Browser: http://git.debian.org/?p=collab-maint/mingw-w64.git;a=summary
-DM-Upload-Allowed: yes
+Vcs-Git: git://anonscm.debian.org/collab-maint/mingw-w64.git
+Vcs-Browser: http://anonscm.debian.org/gitweb/?p=collab-maint/mingw-w64.git;a=summary
 
 Package: mingw-w64-dev
 Section: oldlibs
@@ -28,8 +27,8 @@
 Package: mingw-w64-i686-dev
 Architecture: all
 Depends: ${misc:Depends}
-Breaks: gcc-mingw-w64 (<< 4.6.0), mingw-w64-dev (<< 2.0.3-1)
-Replaces: mingw-w64-dev (<< 2.0.3-1)
+Breaks: gcc-mingw-w64 (<< 4.6.0), mingw-w64-dev (<< 2.0.3-1), mingw-w64-dev (= 3.0~svn4933-1), libpthreads-mingw-w64
+Replaces: mingw-w64-dev (<< 2.0.3-1), mingw-w64-dev (= 3.0~svn4933-1), libpthreads-mingw-w64
 Description: Development files for MinGW-w64 targeting Win32
  MinGW-w64 provides a development and runtime environment for 32- and
  64-bit (x86 and x64) Windows applications using the Windows API and
@@ -41,8 +40,8 @@
 Package: mingw-w64-x86-64-dev
 Architecture: all
 Depends: ${misc:Depends}
-Breaks: gcc-mingw-w64 (<< 4.6.0), mingw-w64-dev (<< 2.0.3-1)
-Replaces: mingw-w64-dev (<< 2.0.3-1)
+Breaks: gcc-mingw-w64 (<< 4.6.0), mingw-w64-dev (<< 2.0.3-1), mingw-w64-dev (= 3.0~svn4933-1), libpthreads-mingw-w64
+Replaces: mingw-w64-dev (<< 2.0.3-1), mingw-w64-dev (= 3.0~svn4933-1), libpthreads-mingw-w64
 Description: Development files for MinGW-w64 targeting Win64
  MinGW-w64 provides a development and runtime environment for 32- and
  64-bit (x86 and x64) Windows applications using the Windows API and

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-
# Build mingw-w64.

SHELL=/bin/bash

# Uncomment this to turn on verbose mode.
#export DH_VERBOSE=1

top_dir := $(shell pwd)
build_dir := $(top_dir)/build
deb_version := $(shell dpkg-parsechangelog | sed -ne "s/^Version: \(.*\)/\1/p")
deb_upstream_version := $(shell echo $(deb_version) | cut -d- -f1)
gnu_upstream_version := $(shell echo $(deb_upstream_version) | cut -d. -f1-3)

# Target architectures
target32 := i686-w64-mingw32
target64 := x86_64-w64-mingw32
targets := $(target32) $(target64)

# Host architecture
host := $(shell dpkg-architecture -qDEB_HOST_GNU_TYPE)

# Host-based tools
HOST_TOOLS := gendef genidl genpeimg
# Targetted tools
TARGET_TOOLS := widl

# Targetted projects
TARGET_PROJECTS := crt libraries-libmangle libraries-winstorecompat libraries-winpthreads
TARGET32_PROJECTS := libraries-pseh

# No hardening support for now, except in the tools (build-arch-stamp)
dpkg_buildflags = DEB_BUILD_MAINT_OPTIONS="hardening=-all" dpkg-buildflags

CFLAGS = $(shell $(dpkg_buildflags) --get CFLAGS)
CPPFLAGS = $(shell $(dpkg_buildflags) --get CPPFLAGS)
CXXFLAGS = $(shell $(dpkg_buildflags) --get CXXFLAGS)
FFLAGS = $(shell $(dpkg_buildflags) --get FFLAGS)
LDFLAGS = $(shell $(dpkg_buildflags) --get LDFLAGS)
export CFLAGS CPPFLAGS CXXFLAGS FFLAGS LDFLAGS

clean:
	dh_testdir
	dh_testroot
	dh_autoreconf_clean
	dh_clean
	rm -rf $(build_dir) $(upstream_dir) autotools_files series tmp *-stamp debian/autoreconf

CONFFLAGS = --prefix=/usr

debian/autoreconf:
	find $(top_dir) -name configure.ac | xargs -n 1 dirname > $@

autoreconf-stamp: debian/autoreconf
	dh_autoreconf
	touch $@

# General rules
# Format: host~target~source-folder
# E.g. i486-linux-gnu~i686-w64-mingw32~tools/widl to build a 32-bit
# Linux-hosted widl targeting 32-bit Windows
rulehost = $(word 1,$(subst ~, ,$(1)))
ruletarget = $(word 2,$(subst ~, ,$(1)))
rulepart = $(word 1,$(subst -, ,$(word 3,$(subst ~, ,$(1)))))
rulefolder = $(word 2,$(subst -, ,$(word 3,$(subst ~, ,$(1)))))
sourcefolder = $(top_dir)/mingw-w64-$(call rulepart,$(1))/$(call rulefolder,$(1))
buildfolder = $(build_dir)/$(call rulehost,$(1))-$(call ruletarget,$(1))-$(call rulepart,$(1))$(call rulefolder,$(1))

######################################################################
# Tools

# gendef requires libmangle
$(host)~$(host)~tools-gendef-configure-stamp: autoreconf-stamp $(host)~$(host)~libraries-libmangle-install-stamp
	dh_auto_configure -D$(call sourcefolder,$(host)~$(host)~tools-gendef) -B$(call buildfolder,$(host)~$(host)~tools-gendef) -- --with-mangle=$(top_dir)/debian/tmp/usr $(shell dpkg-buildflags --export=configure)
	touch $@

build-arch-stamp: $(patsubst %,$(host)~$(host)~tools-%-install-stamp,$(HOST_TOOLS)) $(foreach target,$(targets),$(patsubst %,$(host)~$(target)~tools-%-install-stamp,$(TARGET_TOOLS)))
	touch $@

######################################################################
# Libraries

# Override the header configuration
%~headers-configure-stamp: autoreconf-stamp
	dh_auto_configure -D$(call sourcefolder,$*~headers) -B$(call buildfolder,$*~headers) -- --prefix=/usr/$(call ruletarget,$*~headers) --host=$(call rulehost,$*~headers) --enable-sdk=all --enable-secure-api
	touch $*-headers-configure-stamp

# Override CRT configuration to avoid multilib builds
target32crt := $(target32)~$(target32)~crt
$(target32crt)-configure-stamp: $(target32)~$(target32)~headers-install-stamp autoreconf-stamp
	CPPFLAGS="$(CPPFLAGS) -I$(top_dir)/debian/tmp/usr/$(call ruletarget,$(target32crt))/include" dh_auto_configure -D$(call sourcefolder,$(target32crt)) -B$(call buildfolder,$(target32crt)) -- --prefix=/usr/$(call ruletarget,$(target32crt)) --host=$(call rulehost,$(target32crt)) --target=$(call ruletarget,$(target32crt)) --enable-lib32 --disable-lib64
	touch $@
target64crt := $(target64)~$(target64)~crt
$(target64crt)-configure-stamp: $(target64)~$(target64)~headers-install-stamp autoreconf-stamp
	CPPFLAGS="$(CPPFLAGS) -I$(top_dir)/debian/tmp/usr/$(call ruletarget,$(target64crt))/include" dh_auto_configure -D$(call sourcefolder,$(target64crt)) -B$(call buildfolder,$(target64crt)) -- --prefix=/usr/$(call ruletarget,$(target64crt)) --host=$(call rulehost,$(target64crt)) --target=$(call ruletarget,$(target64crt)) --disable-lib32 --enable-lib64
	touch $@

build-indep-stamp: $(foreach target,$(targets),$(patsubst %,$(target)~$(target)~%-install-stamp,$(TARGET_PROJECTS))) $(patsubst %,$(target32)~$(target32)~%-install-stamp,$(TARGET32_PROJECTS))
	# Move DLLs to lib, change their permissions to 644, drop .la files
	for target in $(targets); do \
		mv $(top_dir)/debian/tmp/usr/$$target/bin/*.dll $(top_dir)/debian/tmp/usr/$$target/lib/; \
		rmdir $(top_dir)/debian/tmp/usr/$$target/bin; \
		chmod 644 $(top_dir)/debian/tmp/usr/$$target/lib/*.dll; \
		rm $(top_dir)/debian/tmp/usr/$$target/lib/*.la; \
	done
	touch $@

build: build-arch
build-arch: build-arch-stamp
build-indep: build-indep-stamp

binary-indep: build-indep
	dh $@

binary-arch: build-arch
	dh $@

binary: binary-indep binary-arch

# If we're targetting the build host, configure for hardening
# If we're targetting the target host, disable hardening (see above),
# change the prefix and use the new headers
%-configure-stamp: autoreconf-stamp
	if [ "$(call rulehost,$*)" = "$(host)" ]; then \
		dh_auto_configure -D$(call sourcefolder,$*) -B$(call buildfolder,$*) -- $(shell dpkg-buildflags --export=configure) --host=$(call rulehost,$*) --target=$(call ruletarget,$*); \
	else \
		CPPFLAGS="$(CPPFLAGS) -I$(top_dir)/debian/tmp/usr/$(call ruletarget,$*)/include" dh_auto_configure -D$(call sourcefolder,$*) -B$(call buildfolder,$*) -- --prefix=/usr/$(call ruletarget,$*) --host=$(call rulehost,$*) --target=$(call ruletarget,$*); \
	fi
	touch $*-configure-stamp

%-build-stamp: %-configure-stamp
	dh_auto_build -D$(call sourcefolder,$*) -B$(call buildfolder,$*)
	touch $*-build-stamp

%-install-stamp: %-build-stamp
	dh_auto_install -D$(call sourcefolder,$*) -B$(call buildfolder,$*)
	touch $*-install-stamp

.PHONY: binary-indep binary-arch binary clean build-indep build-arch build install
